<!-- MIT License -->
<!-- Author: Nick Van Osta -->

<template>
  <div>
    <router-view />

    <p-card-list id="world-list" v-slot="{ state, actions }" :data="worldList">
      <c-card-list v-bind="{ state, actions }">
        <template #default="{ value }">
          <p-card-list-item
            :id="`world-${value.id}`"
            v-slot="{ state: itemState, actions: itemActions }"
            :card-id="value.id"
            :default-img="defaultImg"
            :img="value.img"
            :title="value.title"
            :gradient="cardGradient"
            :to="worldDetails"
            @edit="editWorld"
            @delete="deleteWorld(value.id)"
          >
            <c-card-list-item
              v-bind="{ state: itemState, actions: itemActions }"
            />
          </p-card-list-item>
        </template>

        <template #add>
          <p-card-list-add
            :id="addId"
            v-slot="{ state: newState, actions: newActions }"
            :color="$vuetify.theme.currentTheme.accent"
          >
            <component
              :is="addConsumer"
              v-bind="{ state: newState, actions: newActions }"
              @click="$router.push({ name: 'worlds-new' })"
            />
          </p-card-list-add>
        </template>

        <template #delete>
          <p-card-list-delete
            id="world-delete"
            v-slot="{ state: deleteState, actions: deleteActions }"
            v-model="deleteDialog"
            :mobile="$vuetify.breakpoint.mobile"
            :data="deleteDialog ? worldItems[toDelete] : {}"
            :color="$vuetify.theme.currentTheme.primary"
            :error-color="$vuetify.theme.currentTheme.error"
            @delete="confirmDelete"
          >
            <c-card-list-delete
              v-bind="{ state: deleteState, actions: deleteActions }"
            />
          </p-card-list-delete>
        </template>
      </c-card-list>
    </p-card-list>
  </div>
</template>

<script>
// Providers
import PCardList from '@p/CardList';
import PCardListItem from '@p/CardListItem';
import PCardListAdd from '@p/CardListAdd';
import PCardListDelete from '@p/CardListDelete';

// Consumers
import CCardList from '@c/CardList';
import CCardListItem from '@c/CardListItem';
import CCardListAddItem from '@c/CardListAddItem';
import CCardListAddFab from '@c/CardListAddFab';
import CCardListDelete from '@c/CardListDelete';

// Vuex
import { mapState, mapActions } from 'vuex';
import { APPBAR_MODULE } from '@xm/appbar';
import worldsModule, { WORLDS_MODULE, DEL_WORLD } from '@xm/worlds';
import { SET_TITLE } from '@xm/appbar';

// Router
import { WORLD_DETAILS, WORLDS_EDIT } from '@r';

import Gradient from '@u/gradient';
import CardItem from '@u/card-item';

import defaultImg from '@/assets/worlds/default.png';

export default {
  name: 'WorldList',

  components: {
    PCardList,
    PCardListItem,
    PCardListAdd,
    PCardListDelete,

    CCardList,
    CCardListItem,
    CCardListDelete
  },

  data() {
    return {
      worldDetails: WORLD_DETAILS,

      defaultImg,
      deleteDialog: false,
      toDelete: null
    };
  },

  computed: {
    ...mapState({
      worlds: (state) => state.worlds.list
    }),

    addConsumer() {
      return this.$vuetify.breakpoint.mobile
        ? CCardListAddFab
        : CCardListAddItem;
    },

    addId() {
      return 'world-add-' + (this.$vuetify.breakpoint.mobile ? 'fab' : 'item');
    },

    worldItems() {
      const list = {};
      Object.keys(this.worlds).forEach((id) => {
        list[id] = CardItem.toCardItem(this.worlds[id]);
      });
      return list;
    },

    worldList() {
      return Object.values(this.worldItems);
    },

    cardGradient() {
      return new Gradient(
        {
          from: this.$vuetify.theme.currentTheme.primary,
          to: this.$vuetify.theme.currentTheme.accent
        },
        {
          from: 0.25,
          to: 0.5
        }
      );
    }
  },

  beforeCreate() {
    this.$store.hasModule(WORLDS_MODULE) ||
      this.$store.registerModule(WORLDS_MODULE, worldsModule);
  },

  created() {
    this[SET_TITLE](this.$t('worlds-title'));
  },

  mounted() {
    this.$store.hasModule(WORLDS_MODULE) ||
      this.$store.registerModule(WORLDS_MODULE, worldsModule);
  },

  beforeDestroy() {
    this.$store.unregisterModule(WORLDS_MODULE);
  },

  methods: {
    ...mapActions(APPBAR_MODULE, [SET_TITLE]),
    ...mapActions(WORLDS_MODULE, [DEL_WORLD]),

    editWorld(id) {
      this.$router.push({ name: WORLDS_EDIT, params: { id } });
    },

    deleteWorld(id) {
      this.deleteDialog = true;
      this.toDelete = id;
    },

    confirmDelete(world) {
      URL.revokeObjectURL(world.thumbnail);
      this[DEL_WORLD](world.id);
    }
  }
};
</script>
